/*
 * エフェクトクラス
 */

var Effect = Class.create(Sprite, {
	initialize: function(x, y, width, height, image, type){
		Sprite.call(this, width, height);
		this.image = game.assets[image];
		this.opacity = 1.0;
		this.vy = -rnd(5, 15);
		this.moveTo(x, y);
		this.startFrame = game.frame;
		
		if(type == TYPE_USUAL){
			this.update = this.move1;
		}
		else if(type == TYPE_LAST){
			this.update = this.move2;
		}
	},
	move1: function(){
		// ちょっと上がって下に落ちていく感じ
		this.vy += 0.8;
		this.y += this.vy;
		this.opacity -= 0.02;
		if(this.opacity < 0 || this.y > SCREEN_HEIGHT){
			this.parentNode.removeChild(this);	// シーンから消す
		}
	},
	move2: function(){
		// ぐるぐる回る
		this.rotate(45);
		if(this.rotation > 360) this.rotation = 0;
		// 1.5秒後に停止して消える
		if((game.frame-this.startFrame)/game.fps > 1.5){
			this.rotation = 0;
			this.opacity -= 0.01;
			if(this.opacity < 0){
				this.parentNode.removeChild(this);	// シーンから消す
			}
		}
	},
	onenterframe: function(){
		this.update();
	},
});
