/*
 * 汎用処理
 */

// 乱数生成（最小値, 最大値）
function rnd(min, max){
	return Math.floor(Math.random() * (max-min+1) + min);
}

/*
 * ゲーム初期化
 */
function initGame(){
	no = 0;
	gameEndNo = no + QUESTION_COUNT - 1;
	game.score = 0;
	// 問題番号とスコア表示
	numberText.setText((no+1) + "/" + QUESTION_COUNT);
	scoreText.setText("SCORE: " + game.score);
	// 問題表示
	var type = RANDOM;
	setMondai(type);
	showQuestion();
}

/*
 * ゲーム開始
 */
function startGame(){
	game.replaceScene(scGame);
	game.mode = GAME;
	console.log("Mode: " + game.mode)
}

/*
 * setMondai(type) 問題の出題順を決める
 *			@type
 * 				0 : ランダムで出題
 *				1 : 都道府県番号順に出題
 */
function setMondai(type){
	// 都道府県番号順に配列に格納（type == NORMAL: 都道府県番号順に出題）
	for(var i=0; i<PREFS; i++){
		mondai[i] = i;
	}
	// 出題タイプ
	if(type == RANDOM){	// ランダムで出題
		// シャッフル処理
		for(var i=0; i<1000; i++){
			var r1 = rnd(0, PREFS-1);
			var r2 = rnd(0, PREFS-1);
			var work = mondai[r1];
			mondai[r1] = mondai[r2];
			mondai[r2] = work;
		}
	}
}

/*
 * showQuestion() 問題を表示する
 */
function showQuestion(){
	console.log("問題: " + no);
	map.image = game.assets[MAP_ASSETS[mondai[no]]];
	// 解答欄を適当に表示する
	var prefDummy = [];
	for(var i=0; i<PREFS; i++){
		prefDummy[i] = i;
	}
	for(var i=0; i<1000; i++){
		var r1 = rnd(0, PREFS-1);
		var r2 = rnd(0, PREFS-1);
		var work = prefDummy[r1];
		prefDummy[r1] = prefDummy[r2];
		prefDummy[r2] = work
	}
	// 解答欄をランダムで生成
	var kaitou = [];
	kaitou.push(mondai[no]);	// 正答をまず1番目の配列に格納

	var count = 1;
	var i = 0;
	console.log("count : " + count + "i : " + i);

	while(count < button.length){
		if(prefDummy[i] != mondai[no]){	// 正答と違うものだけ格納
			kaitou.push(prefDummy[i]);
			count++;
			i++;
			console.log("PUSH/ count : " + count + "i : " + i);
		}
		else{
			i++;
			console.log("THROW/ count : " + count + "i : " + i);
		}
	}
	// 解答欄をシャッフル
	for(var i=0; i<100; i++){
		var r1 = rnd(0, kaitou.length-1);
		var r2 = rnd(0, kaitou.length-1);
		var work = kaitou[r1];
		kaitou[r1] = kaitou[r2];
		kaitou[r2] = work
	}
	// 解答欄を表示
	for(var i in button){
		button[i].release();
		button[i].setText(prefs[kaitou[i]]);
//		if(kaitou[i] == mondai[no]) button[i].label.color = "red";	// 正解を赤に（テストプレイ用）
	}
}

/*
 * nextQuestion() 次の問題を表示する
 */
function nextQuestion(){
	no++;
	numberText.setText((no+1) + "/" + QUESTION_COUNT);
	showQuestion();
}
