/*
 * ラベルボタンクラス（ラベルクラスとスプライトクラスを結合してボタンに見せるクラス）
 */
var LabelButton = Class.create(Group, {
	initialize: function(x, y, text){
		Group.call(this, BUTTON_WIDTH, BUTTON_HEIGHT);
		this.moveTo(x, y);
		// ボタンの画像（スプライトクラスを使用）
		this.button = new Sprite(BUTTON_WIDTH, BUTTON_HEIGHT);
		this.button.image = game.assets[IMG_BUTTON];
		this.addChild(this.button);
		// ボタンのラベル（ラベルクラスを使用）
		this.label = new Label(text);
		this.label.font = BUTTON_FONT;
		this.label.text = text;
		this.label.width = this.width;
		this.label.height = this.height;
		console.log("text.length = " + text.length);
		this.label.x = this.centerX(text);
		this.label.y = 19;
		this.addChild(this.label);
		this.show();
	},
	centerX: function(text){
		return(this.button.width/2 - (text.length * 16)/2);		// 文字を中央に配置
	},
	setText: function(text){
		this.label.x = this.centerX(text);
		this.label.text = text;
	},
	show: function(){
		this.button.visible = true;
		this.label.visible = true;
	},
	hide: function(){
		this.button.visible = false;
		this.label.visible = false;
	},
	push: function(){
		this.button.image = game.assets[IMG_BUTTONPUSH];
		this.label.color = "#fff";
	},
	release: function(){
		this.button.image = game.assets[IMG_BUTTON];
		this.label.color = "#000";
	},
	ontouchstart: function(){
		this.push();
	},
	ontouchend: function(){		// 押し終えた時、解答チェックする
		if(game.mode == GAME){
			game.mode = EFFECT;
			console.log("Mode: " + game.mode)
			this.release();
			// 正誤チェック
			var marubatu = null;
			if(this.label.text == prefs[mondai[no]]){		// 正解
				marubatu = new Marubatu(0, 0, IMG_MARUBATU, 0);	// ○を表示
				game.score++;
				console.log("Score: " + game.score);
				scoreText.setText("Score: " + game.score);
				// 盛り上げるためのエフェクト
				if(game.score % 3 == 0){		// Great!
					scGame.addChild(new Effect(SCREEN_WIDTH/2-80, SCREEN_HEIGHT/2-100, 160, 60, IMG_GREAT, TYPE_USUAL));
				}
				if(game.score % 5 == 0){		// ファンタスティック！
					scGame.addChild(new Effect(rnd(0, SCREEN_WIDTH-358), rnd(0, SCREEN_HEIGHT/4), 358, 180, IMG_FANTASTIC, TYPE_USUAL));
				}
				if(game.score == 24){			// あと半分！
					scGame.addChild(new Effect(SCREEN_WIDTH/2 - 301/2, SCREEN_HEIGHT/4, 301, 82, IMG_CENTER, TYPE_USUAL));
				}
				else if(game.score == PREFS-3){	// あと３つ！
					scGame.addChild(new Effect(SCREEN_WIDTH/2 - 301/2, SCREEN_HEIGHT/4, 301, 79, IMG_LAST3, TYPE_USUAL));
				}
				else if(game.score == PREFS-1){	// あと１!!
					scGame.addChild(new Effect(SCREEN_WIDTH/2 - 321/2, SCREEN_HEIGHT/4, 321, 101, IMG_LAST1, TYPE_USUAL));
				}
			}
			else{	// 不正解
				marubatu = new Marubatu(0, 0, IMG_MARUBATU, 1);	// ×を表示
			}
			scGame.addChild(marubatu);
		}
	},
});
